package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.PricingEspecificoAgenciaDAO;
import com.rjconsultores.ventaboletos.entidad.PricingEspecificoAgencia;
import com.rjconsultores.ventaboletos.service.PricingEspecificoAgenciaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("pricingEspecificoAgenciaService")
public class PricingEspecificoAgenciaServiceImpl implements PricingEspecificoAgenciaService {
    @Autowired
    private PricingEspecificoAgenciaDAO pricingEspecificoAgenciaDAO;
    
	@Override
	public List<PricingEspecificoAgencia> obtenerTodos() {
		return pricingEspecificoAgenciaDAO.obtenerTodos();
	}

	@Override
	public PricingEspecificoAgencia obtenerID(Long id) {
		return pricingEspecificoAgenciaDAO.obtenerID(id);
	}

	@Override
	@Transactional
	public PricingEspecificoAgencia suscribir(PricingEspecificoAgencia entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
//        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingEspecificoAgenciaDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public PricingEspecificoAgencia actualizacion(PricingEspecificoAgencia entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());

		return pricingEspecificoAgenciaDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(PricingEspecificoAgencia entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        pricingEspecificoAgenciaDAO.actualizacion(entidad);
	}
	@Override
	public Boolean existeAgenciaPricing (PricingEspecificoAgencia entidad){
		return pricingEspecificoAgenciaDAO.isDuplicado(entidad);
	}

}
